#pragma once

#include "gui.h"
#include "framebuffer.h"
#include "ppc.h"
#include "tmesh.h"
#include "CGInterface.h"

class Scene {
public:
  
  // gpu programming
  CGInterface *cgi;
  ShaderOneInterface *soi;

  TMesh tmesh, tmesh1;
  TMesh *fbmesh;
  PPC *ppc, *shadowPPC;
  GUI *gui;
  FrameBuffer *fb, *hwfb, *shadowMap;
  FrameBuffer *texture, *texture1;
  Scene();
  void DBG();
  void Render();
  void RenderHWGPU();
  void Setup();
  void RenderGL();
  void RenderGPU();
};

extern Scene *scene;
